#include "print.h"

#include <fstream.h>
#include <iostream.h>

//---------------------------------------------------------------------
Print::Print()
{
doSaveP = false;
doShowP = false;
doSaveT = false;
doShowT = false;
}
//---------------------------------------------------------------------
void Print::SetSaveP()
{
doSaveP = true;

PFile.open("Prims.txt", ios::out);
}
//---------------------------------------------------------------------
void Print::SetSaveT()
{
doSaveT = true;

TFile.open("Twins.txt", ios::out);
}
//---------------------------------------------------------------------
void Print::SetShowP()
{
doShowP = true;
doShowT = false;
}
//---------------------------------------------------------------------
void Print::SetShowT()
{
doShowP = false;
doShowT = true;
}
//---------------------------------------------------------------------
bool Print::bActive()
{
return (doShowP || doShowT || doSaveP || doSaveT);
}
//---------------------------------------------------------------------
bool Print::bShow()
{
return (!doShowP && !doShowT);
}
//---------------------------------------------------------------------
int Print::GetSize(INTEGER pNr)
{
int i = 1;

for(INTEGER j = 10; j < pNr; j *= 10) i++;

return i;
}
//---------------------------------------------------------------------
void Print::Prime(INTEGER pNr)
{
if(doSaveP) this->SavePrime(pNr);
if(doShowP) this->ShowPrime(pNr);
}
//---------------------------------------------------------------------
void Print::Twin(INTEGER pNr)
{
if(doSaveT) this->SaveTwin(pNr);
if(doShowT) this->ShowTwin(pNr);
}
//---------------------------------------------------------------------
void Print::ShowPrime(INTEGER pNr)
{
static int olds = 0;
static int size = 0;
static int line = 0;

olds = size;
size = GetSize(pNr) + 2;
line = line + size;

if((olds == 0 || olds == size) && (line < 80))
	{
	cout << pNr << ", ";

	return;
	}

if(olds != size)

cout << endl;
cout << endl;
cout << pNr << ", ";

line = size;
}
//---------------------------------------------------------------------
void Print::SavePrime(INTEGER pNr)
{
static int olds = 0;
static int size = 0;
static int line = 0;

olds = size;
size = GetSize(pNr) + 2;
line = line + size;

if((olds == 0 || olds == size) && (line < 80))
	{
	PFile << pNr << ", ";

	return;
	}

if(olds != size)

PFile << endl;
PFile << endl;
PFile << pNr << ", ";

line = size;
}
//---------------------------------------------------------------------
void Print::ShowTwin(INTEGER pNr)
{
INTEGER n1	= pNr - 2;
INTEGER n2	= pNr;

static int olds = 0;
static int size = 0;
static int line = 0;

olds = size;
size = GetSize(n1) + GetSize(n2) + 4;
line = line + size;

if((olds == 0 || olds == size) && (line < 80))
	{
	cout << "[" << n1  << " ";
	cout << n2  << "]" << " ";

	return;
	}

if(olds != size)

cout << endl;
cout << endl;
cout << "[" << n1  << " ";
cout << n2  << "]" << " ";

line = size;
}
//---------------------------------------------------------------------
void Print::SaveTwin(INTEGER pNr)
{
INTEGER n1	= pNr - 2;
INTEGER n2	= pNr;

static int olds = 0;
static int size = 0;
static int line = 0;

olds = size;
size = GetSize(n1) + GetSize(n2) + 4;
line = line + size;

if((olds == 0 || olds == size) && (line < 80))
	{
	TFile << "[" << n1  << " ";
	TFile << n2  << "]" << " ";

	return;
	}

if(olds != size)

TFile << endl;
TFile << endl;
TFile << "[" << n1  << " ";
TFile << n2  << "]" << " ";

line = size;
}
//---------------------------------------------------------------------